? xemacs-native.patch
Index: src/buffer.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/buffer.c,v
retrieving revision 1.67
diff -u -b -r1.67 buffer.c
--- src/buffer.c	2004/11/04 23:06:15	1.67
+++ src/buffer.c	2004/12/01 03:22:57
@@ -74,6 +74,9 @@
 */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "buffer.h"
Index: src/cmdloop.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/cmdloop.c,v
retrieving revision 1.22
diff -u -b -r1.22 cmdloop.c
--- src/cmdloop.c	2004/09/20 19:19:35	1.22
+++ src/cmdloop.c	2004/12/01 03:25:24
@@ -29,6 +29,9 @@
    should just be merged into event-stream.c, given its shortness. */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "buffer.h"
Index: src/console-msw-impl.h
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/console-msw-impl.h,v
retrieving revision 1.3
diff -u -b -r1.3 console-msw-impl.h
--- src/console-msw-impl.h	2003/01/12 11:08:09	1.3
+++ src/console-msw-impl.h	2004/12/01 03:03:20
@@ -35,8 +35,8 @@
 #ifndef INCLUDED_console_msw_impl_h_
 #define INCLUDED_console_msw_impl_h_
 
-#include "console-impl.h"
 #include "console-msw.h"
+#include "console-impl.h"
 
 /*
  * Consoles
Index: src/console-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/console-msw.c,v
retrieving revision 1.18
diff -u -b -r1.18 console-msw.c
--- src/console-msw.c	2004/11/04 23:06:18	1.18
+++ src/console-msw.c	2004/12/01 03:03:54
@@ -32,9 +32,9 @@
 /* See win32.c for info about the different Windows files in XEmacs. */
 
 #include <config.h>
-#include "lisp.h"
 
 #include "console-msw-impl.h"
+#include "lisp.h"
 #include "events.h"
 #include "opaque.h"
 
Index: src/console-msw.h
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/console-msw.h,v
retrieving revision 1.46
diff -u -b -r1.46 console-msw.h
--- src/console-msw.h	2004/11/04 23:06:18	1.46
+++ src/console-msw.h	2004/12/01 03:02:30
@@ -37,8 +37,9 @@
 
 /* See win32.c for info about the different Windows files in XEmacs. */
 
-#include "console.h"
 #include "syswindows.h"
+#include "lisp.h"
+#include "console.h"
 
 #ifdef HAVE_XPM
 #include <X11/xpm.h>
Index: src/device-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/device-msw.c,v
retrieving revision 1.54
diff -u -b -r1.54 device-msw.c
--- src/device-msw.c	2004/11/04 23:06:19	1.54
+++ src/device-msw.c	2004/12/01 03:12:25
@@ -36,14 +36,13 @@
 #define NEED_MSWINDOWS_OBJBASE /* for CoInitialize */
 
 #include <config.h>
+#include "console-msw-impl.h"
 #include "lisp.h"
 
 #include "device-impl.h"
 #include "events.h"
 #include "faces.h"
 #include "frame.h"
-
-#include "console-msw-impl.h"
 #include "console-stream.h"
 #include "objects-msw.h"
 
Index: src/dialog-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/dialog-msw.c,v
retrieving revision 1.31
diff -u -b -r1.31 dialog-msw.c
--- src/dialog-msw.c	2004/11/04 23:06:20	1.31
+++ src/dialog-msw.c	2004/12/01 03:21:38
@@ -29,6 +29,7 @@
 */
 
 #include <config.h>
+#include "console-msw-impl.h"
 #include "lisp.h"
 
 #include "buffer.h"
@@ -36,7 +37,6 @@
 #include "gui.h"
 #include "opaque.h"
 
-#include "console-msw-impl.h"
 
 #include "sysfile.h"
 
Index: src/dired-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/dired-msw.c,v
retrieving revision 1.17
diff -u -b -r1.17 dired-msw.c
--- src/dired-msw.c	2004/11/04 23:06:21	1.17
+++ src/dired-msw.c	2004/12/01 03:20:12
@@ -72,13 +72,13 @@
 
 
 #include <config.h>
+#include "console-msw.h"
 #include "lisp.h"
 
 #include "buffer.h"
 #include "regex.h"
 #include "syntax.h"
 
-#include "console-msw.h"
 
 #include "sysdir.h"
 #include "sysfile.h"
Index: src/dired.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/dired.c,v
retrieving revision 1.38
diff -u -b -r1.38 dired.c
--- src/dired.c	2004/11/04 23:06:21	1.38
+++ src/dired.c	2004/12/01 03:27:34
@@ -22,6 +22,9 @@
 /* Synched up with: FSF 19.30. */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "buffer.h"
Index: src/dumper.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/dumper.c,v
retrieving revision 1.20
diff -u -b -r1.20 dumper.c
--- src/dumper.c	2004/11/04 23:06:22	1.20
+++ src/dumper.c	2004/12/01 03:22:32
@@ -35,6 +35,9 @@
    since it will follow a strict format in its header. */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "specifier.h"
Index: src/emacs.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/emacs.c,v
retrieving revision 1.150
diff -u -b -r1.150 emacs.c
--- src/emacs.c	2004/11/04 23:06:24	1.150
+++ src/emacs.c	2004/12/01 03:27:56
@@ -375,6 +375,9 @@
    the build dir, will be used. */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "backtrace.h" /* run-emacs-from-temacs needs this */
Index: src/event-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/event-msw.c,v
retrieving revision 1.100
diff -u -b -r1.100 event-msw.c
--- src/event-msw.c	2004/11/04 23:06:26	1.100
+++ src/event-msw.c	2004/12/01 03:13:21
@@ -37,6 +37,7 @@
 #define NEED_MSWINDOWS_SHLOBJ /* for IShellLink */
 
 #include <config.h>
+#include "console-msw-impl.h"
 #include "lisp.h"
 
 #ifdef CYGWIN
@@ -82,7 +83,6 @@
 #include "window.h"
 
 #include "console-stream-impl.h"
-#include "console-msw-impl.h"
 #include "objects-msw-impl.h"
 
 #ifdef HAVE_SCROLLBARS
Index: src/fileio.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/fileio.c,v
retrieving revision 1.101
diff -u -b -r1.101 fileio.c
--- src/fileio.c	2004/11/04 23:06:29	1.101
+++ src/fileio.c	2004/12/01 03:28:26
@@ -29,6 +29,9 @@
 
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "buffer.h"
Index: src/frame-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/frame-msw.c,v
retrieving revision 1.55
diff -u -b -r1.55 frame-msw.c
--- src/frame-msw.c	2004/11/04 23:06:30	1.55
+++ src/frame-msw.c	2004/12/01 03:17:54
@@ -32,6 +32,7 @@
  */
 
 #include <config.h>
+#include "console-msw-impl.h"
 #include "lisp.h"
 
 #include "buffer.h"
@@ -43,7 +44,6 @@
 #include "redisplay.h"
 #include "window.h"
 
-#include "console-msw-impl.h"
 #include "glyphs-msw.h"
 
 #define MSWINDOWS_FRAME_STYLE (WS_CLIPCHILDREN | WS_CLIPSIBLINGS | WS_OVERLAPPEDWINDOW)
Index: src/glyphs-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/glyphs-msw.c,v
retrieving revision 1.53
diff -u -b -r1.53 glyphs-msw.c
--- src/glyphs-msw.c	2004/11/04 23:06:33	1.53
+++ src/glyphs-msw.c	2004/12/01 03:18:22
@@ -29,6 +29,7 @@
 #define NEED_MSWINDOWS_COMMCTRL
 
 #include <config.h>
+#include "console-msw-impl.h"
 #include "lisp.h"
 
 #include "device-impl.h"
@@ -45,7 +46,6 @@
 #include "sysfile.h"
 #include "window.h"
 
-#include "console-msw-impl.h"
 #include "glyphs-msw.h"
 #include "objects-msw-impl.h"
 
Index: src/gui-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/gui-msw.c,v
retrieving revision 1.10
diff -u -b -r1.10 gui-msw.c
--- src/gui-msw.c	2004/11/04 23:06:34	1.10
+++ src/gui-msw.c	2004/12/01 03:18:46
@@ -25,8 +25,8 @@
    5-2000. */
 
 #include <config.h>
-#include "lisp.h"
 #include "console-msw-impl.h"
+#include "lisp.h"
 #include "redisplay.h"
 #include "gui.h"
 #include "glyphs.h"
Index: src/intl-auto-encap-win32.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/intl-auto-encap-win32.c,v
retrieving revision 1.9
diff -u -b -r1.9 intl-auto-encap-win32.c
--- src/intl-auto-encap-win32.c	2004/11/04 23:06:36	1.9
+++ src/intl-auto-encap-win32.c	2004/12/01 03:43:02
@@ -7,6 +7,9 @@
 */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "syswindows.h"
@@ -2633,9 +2636,9 @@
 qxeImmSetCompositionString (HIMC arg1, DWORD dwIndex, LPCVOID lpComp, DWORD arg4, LPCVOID lpRead, DWORD arg6)
 {
   if (XEUNICODE_P)
-    return ImmSetCompositionStringW (arg1, dwIndex, lpComp, arg4, lpRead, arg6);
+    return ImmSetCompositionStringW (arg1, dwIndex, (LPVOID)lpComp, arg4, (LPVOID)lpRead, arg6);
   else
-    return ImmSetCompositionStringA (arg1, dwIndex, lpComp, arg4, lpRead, arg6);
+    return ImmSetCompositionStringA (arg1, dwIndex, (LPVOID)lpComp, arg4, (LPVOID)lpRead, arg6);
 }
 
 #endif /* defined (HAVE_MS_WINDOWS) */
@@ -3149,16 +3152,16 @@
 qxeEnumResourceTypes (HMODULE hModule, ENUMRESTYPEPROC lpEnumFunc, LONG lParam)
 {
   if (XEUNICODE_P)
-    return EnumResourceTypesW (hModule, lpEnumFunc, lParam);
+    return EnumResourceTypesW (hModule, (ENUMRESTYPEPROCW)lpEnumFunc, lParam);
   else
-    return EnumResourceTypesA (hModule, lpEnumFunc, lParam);
+    return EnumResourceTypesA (hModule, (ENUMRESTYPEPROCA)lpEnumFunc, lParam);
 }
 
 BOOL
 qxeEnumResourceNames (HMODULE hModule, const Extbyte * lpType, ENUMRESNAMEPROC lpEnumFunc, LONG lParam)
 {
   if (XEUNICODE_P)
-    return EnumResourceNamesW (hModule, (LPCWSTR) lpType, lpEnumFunc, lParam);
+    return EnumResourceNamesW (hModule, (LPCWSTR) lpType, (ENUMRESNAMEPROCW)lpEnumFunc, lParam);
   else
     return EnumResourceNamesA (hModule, (LPCSTR) lpType, lpEnumFunc, lParam);
 }
@@ -3167,7 +3170,7 @@
 qxeEnumResourceLanguages (HMODULE hModule, const Extbyte * lpType, const Extbyte * lpName, ENUMRESLANGPROC lpEnumFunc, LONG lParam)
 {
   if (XEUNICODE_P)
-    return EnumResourceLanguagesW (hModule, (LPCWSTR) lpType, (LPCWSTR) lpName, lpEnumFunc, lParam);
+    return EnumResourceLanguagesW (hModule, (LPCWSTR) lpType, (LPCWSTR) lpName, (ENUMRESLANGPROCW)lpEnumFunc, lParam);
   else
     return EnumResourceLanguagesA (hModule, (LPCSTR) lpType, (LPCSTR) lpName, lpEnumFunc, lParam);
 }
Index: src/intl-encap-win32.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/intl-encap-win32.c,v
retrieving revision 1.12
diff -u -b -r1.12 intl-encap-win32.c
--- src/intl-encap-win32.c	2004/11/04 23:06:38	1.12
+++ src/intl-encap-win32.c	2004/12/01 03:29:18
@@ -32,6 +32,9 @@
 #define NEED_MSWINDOWS_SHLOBJ
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "console-msw.h"
Index: src/intl-win32.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/intl-win32.c,v
retrieving revision 1.13
diff -u -b -r1.13 intl-win32.c
--- src/intl-win32.c	2004/11/04 23:06:38	1.13
+++ src/intl-win32.c	2004/12/01 03:28:52
@@ -33,6 +33,9 @@
    */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "elhash.h"
Index: src/lread.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/lread.c,v
retrieving revision 1.72
diff -u -b -r1.72 lread.c
--- src/lread.c	2004/11/04 23:06:40	1.72
+++ src/lread.c	2004/12/01 03:31:29
@@ -25,6 +25,9 @@
 /* This file has been Mule-ized. */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "buffer.h"
Index: src/menubar-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/menubar-msw.c,v
retrieving revision 1.43
diff -u -b -r1.43 menubar-msw.c
--- src/menubar-msw.c	2004/11/04 23:06:41	1.43
+++ src/menubar-msw.c	2004/12/01 03:20:33
@@ -80,11 +80,11 @@
  */
 
 #include <config.h>
+#include "console-msw-impl.h"
 #include "lisp.h"
 
 #include "buffer.h"
 #include "commands.h"
-#include "console-msw-impl.h"
 #include "elhash.h"
 #include "events.h"
 #include "frame-impl.h"
Index: src/nt.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/nt.c,v
retrieving revision 1.44
diff -u -b -r1.44 nt.c
--- src/nt.c	2004/11/04 23:06:44	1.44
+++ src/nt.c	2004/12/01 03:32:06
@@ -36,6 +36,9 @@
 /* This file Mule-ized by Ben Wing, 6-23-00. */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "buffer.h"
Index: src/ntplay.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/ntplay.c,v
retrieving revision 1.12
diff -u -b -r1.12 ntplay.c
--- src/ntplay.c	2004/11/04 23:06:45	1.12
+++ src/ntplay.c	2004/12/01 03:32:29
@@ -24,6 +24,9 @@
 /* This file Mule-ized by Ben Wing, 5-15-01. */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "sound.h"
Index: src/objects-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/objects-msw.c,v
retrieving revision 1.43
diff -u -b -r1.43 objects-msw.c
--- src/objects-msw.c	2004/11/04 23:06:45	1.43
+++ src/objects-msw.c	2004/12/01 03:19:06
@@ -36,9 +36,9 @@
 /* TODO: palette handling */
 
 #include <config.h>
+#include "console-msw-impl.h"
 #include "lisp.h"
 
-#include "console-msw-impl.h"
 #include "objects-msw-impl.h"
 
 #include "buffer.h"
Index: src/print.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/print.c,v
retrieving revision 1.51
diff -u -b -r1.51 print.c
--- src/print.c	2004/11/04 23:06:46	1.51
+++ src/print.c	2004/12/01 03:32:40
@@ -33,6 +33,9 @@
    Martin? */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "backtrace.h"
Index: src/process-nt.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/process-nt.c,v
retrieving revision 1.35
diff -u -b -r1.35 process-nt.c
--- src/process-nt.c	2004/11/04 23:06:46	1.35
+++ src/process-nt.c	2004/12/01 03:33:11
@@ -30,6 +30,9 @@
    calls a subprocess is in win32-native.el */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "console-msw.h"
Index: src/process.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/process.c,v
retrieving revision 1.65
diff -u -b -r1.65 process.c
--- src/process.c	2004/11/04 23:06:47	1.65
+++ src/process.c	2004/12/01 03:33:04
@@ -34,6 +34,9 @@
 */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 
 #if defined (NO_SUBPROCESSES)
 #error "We don't support this anymore."
Index: src/realpath.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/realpath.c,v
retrieving revision 1.19
diff -u -b -r1.19 realpath.c
--- src/realpath.c	2004/11/04 23:06:48	1.19
+++ src/realpath.c	2004/12/01 03:33:20
@@ -29,6 +29,9 @@
    data.  This is the only way to be safe, and it makes the code cleaner. */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "sysfile.h"
Index: src/redisplay-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/redisplay-msw.c,v
retrieving revision 1.41
diff -u -b -r1.41 redisplay-msw.c
--- src/redisplay-msw.c	2004/11/04 23:06:48	1.41
+++ src/redisplay-msw.c	2004/12/01 03:19:28
@@ -35,6 +35,7 @@
    for 21.0.  */
 
 #include <config.h>
+#include "console-msw-impl.h"
 #include "lisp.h"
 
 #include "buffer.h"
@@ -49,7 +50,6 @@
 #include "sysdep.h"
 #include "window-impl.h"
 
-#include "console-msw-impl.h"
 #include "glyphs-msw.h"
 #include "objects-msw-impl.h"
 
Index: src/scrollbar-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/scrollbar-msw.c,v
retrieving revision 1.28
diff -u -b -r1.28 scrollbar-msw.c
--- src/scrollbar-msw.c	2004/09/20 19:19:58	1.28
+++ src/scrollbar-msw.c	2004/12/01 03:20:56
@@ -28,6 +28,7 @@
    5-2000. */
 
 #include <config.h>
+#include "console-msw-impl.h"
 #include "lisp.h"
 
 #include "device.h"
@@ -39,7 +40,6 @@
 #include "specifier.h"
 #include "window-impl.h"
 
-#include "console-msw-impl.h"
 #include "scrollbar-msw.h"
 
 /* We use a similar sort of vertical scrollbar drag hack for mswindows
Index: src/select-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/select-msw.c,v
retrieving revision 1.15
diff -u -b -r1.15 select-msw.c
--- src/select-msw.c	2004/09/20 19:19:59	1.15
+++ src/select-msw.c	2004/12/01 03:19:50
@@ -32,6 +32,7 @@
 */
 
 #include <config.h>
+#include "console-msw-impl.h"
 #include "lisp.h"
 #include "buffer.h"
 #include "frame-impl.h"
@@ -39,7 +40,6 @@
 #include "opaque.h"
 #include "file-coding.h"
 
-#include "console-msw-impl.h"
 
 static int in_own_selection;
 
Index: src/sound.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/sound.c,v
retrieving revision 1.22
diff -u -b -r1.22 sound.c
--- src/sound.c	2004/11/04 23:06:53	1.22
+++ src/sound.c	2004/12/01 03:33:29
@@ -29,6 +29,9 @@
 
 #include <config.h>
 #include <time.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "buffer.h"
Index: src/sysdep.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/sysdep.c,v
retrieving revision 1.77
diff -u -b -r1.77 sysdep.c
--- src/sysdep.c	2004/11/04 23:06:55	1.77
+++ src/sysdep.c	2004/12/01 03:33:44
@@ -39,6 +39,9 @@
    */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 /* ------------------------------- */
Index: src/syswindows.h
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/syswindows.h,v
retrieving revision 1.23
diff -u -b -r1.23 syswindows.h
--- src/syswindows.h	2004/11/04 23:06:55	1.23
+++ src/syswindows.h	2004/12/01 03:06:13
@@ -506,6 +506,7 @@
 
 #define ERROR_WHEN_NONINTERCEPTED_FUNS_USED
 
+#include "lisp.h"
 #include "intl-auto-encap-win32.h"
 
 /* would be encapsulatable but for parsing problems */
Index: src/toolbar-msw.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/toolbar-msw.c,v
retrieving revision 1.24
diff -u -b -r1.24 toolbar-msw.c
--- src/toolbar-msw.c	2004/09/20 19:20:03	1.24
+++ src/toolbar-msw.c	2004/12/01 03:21:15
@@ -33,6 +33,7 @@
 #define NEED_MSWINDOWS_COMMCTRL
 
 #include <config.h>
+#include "console-msw-impl.h"
 #include "lisp.h"
 
 #include "device.h"
@@ -43,7 +44,6 @@
 #include "toolbar.h"
 #include "window.h"
 
-#include "console-msw-impl.h"
 #include "glyphs-msw.h"
 /* #include "objects-msw.h" */
 
Index: src/win32.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/win32.c,v
retrieving revision 1.23
diff -u -b -r1.23 win32.c
--- src/win32.c	2004/11/04 23:06:58	1.23
+++ src/win32.c	2004/12/01 03:34:36
@@ -19,6 +19,9 @@
 02111-1307, USA. */
 
 #include <config.h>
+#ifdef WIN32_NATIVE
+#include "console-msw-impl.h"
+#endif
 #include "lisp.h"
 
 #include "buffer.h"