Index: frame-x.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/frame-x.c,v
retrieving revision 1.54
diff -u -w -u -w -r1.54 frame-x.c
--- frame-x.c	2002/05/05 11:31:31	1.54
+++ frame-x.c	2002/06/03 11:47:38
@@ -453,14 +453,6 @@
   def (Qunsplittable, XtNunsplittable);
 #endif
   defi(Qinternal_border_width, XtNinternalBorderWidth);
-#ifdef HAVE_TOOLBARS
-  def (Qtop_toolbar_shadow_color, XtNtopToolBarShadowColor);
-  def (Qbottom_toolbar_shadow_color, XtNbottomToolBarShadowColor);
-  def (Qbackground_toolbar_color, XtNbackgroundToolBarColor);
-  def (Qtop_toolbar_shadow_pixmap, XtNtopToolBarShadowPixmap);
-  def (Qbottom_toolbar_shadow_pixmap, XtNbottomToolBarShadowPixmap);
-  defi(Qtoolbar_shadow_thickness, XtNtoolBarShadowThickness);
-#endif
   def (Qscrollbar_placement, XtNscrollBarPlacement);
   defi(Qinter_line_space, XtNinterline);
   /* font, foreground */
@@ -567,16 +559,6 @@
     return make_int (w->emacs_frame.internal_border_width);
   if (EQ (Qborder_color, property))
     return color_to_string (gw, w->core.border_pixel);
-#ifdef HAVE_TOOLBARS
-  if (EQ (Qtop_toolbar_shadow_color, property))
-    return color_to_string (gw, w->emacs_frame.top_toolbar_shadow_pixel);
-  if (EQ (Qbottom_toolbar_shadow_color, property))
-    return color_to_string (gw, w->emacs_frame.bottom_toolbar_shadow_pixel);
-  if (EQ (Qbackground_toolbar_color, property))
-    return color_to_string (gw, w->emacs_frame.background_toolbar_pixel);
-  if (EQ (Qtoolbar_shadow_thickness, property))
-    return make_int (w->emacs_frame.toolbar_shadow_thickness);
-#endif /* HAVE_TOOLBARS */
   if (EQ (Qinter_line_space, property))
     return make_int (w->emacs_frame.interline);
   if (EQ (Qwindow_id, property))
@@ -593,12 +575,6 @@
     || EQ (property, Qborder_width)
     || EQ (property, Qinternal_border_width)
     || EQ (property, Qborder_color)
-#ifdef HAVE_TOOLBARS
-    || EQ (property, Qtop_toolbar_shadow_color)
-    || EQ (property, Qbottom_toolbar_shadow_color)
-    || EQ (property, Qbackground_toolbar_color)
-    || EQ (property, Qtoolbar_shadow_thickness)
-#endif /* HAVE_TOOLBARS */
     || EQ (property, Qinter_line_space)
     || EQ (property, Qwindow_id)
     || STRINGP (property);
@@ -615,21 +591,6 @@
 
   props = cons3 (Qwindow_id, Fx_window_id (wrap_frame (f)), props);
   props = cons3 (Qinter_line_space, make_int (w->emacs_frame.interline), props);
-
-#ifdef HAVE_TOOLBARS
-  props = cons3 (Qtoolbar_shadow_thickness,
-		 make_int (w->emacs_frame.toolbar_shadow_thickness),
-		 props);
-  props = cons3 (Qbackground_toolbar_color,
-		 color_to_string (gw, w->emacs_frame.background_toolbar_pixel),
-		 props);
-  props = cons3 (Qbottom_toolbar_shadow_color,
-		 color_to_string (gw, w->emacs_frame.bottom_toolbar_shadow_pixel),
-		 props);
-  props = cons3 (Qtop_toolbar_shadow_color,
-		 color_to_string (gw, w->emacs_frame.top_toolbar_shadow_pixel),
-		 props);
-#endif /* HAVE_TOOLBARS */
 
   props = cons3 (Qborder_color,
 		 color_to_string (gw, w->core.border_pixel), props);
Index: EmacsFrame.c
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/EmacsFrame.c,v
retrieving revision 1.21
diff -u -w -u -w -r1.21 EmacsFrame.c
--- EmacsFrame.c	2002/03/31 08:27:40	1.21
+++ EmacsFrame.c	2002/06/03 11:47:39
@@ -131,24 +131,6 @@
   { XtNrightToolBarBorderWidth, XtCRightToolBarBorderWidth,
     XtRInt, sizeof (int),
     offset (right_toolbar_border_width), XtRImmediate, (XtPointer)-1 },
-  { XtNtopToolBarShadowColor, XtCTopToolBarShadowColor,
-    XtRPixel, sizeof (Pixel),
-    offset(top_toolbar_shadow_pixel), XtRString, (XtPointer) "#000000" },
-  { XtNbottomToolBarShadowColor, XtCBottomToolBarShadowColor,
-    XtRPixel, sizeof (Pixel),
-    offset (bottom_toolbar_shadow_pixel), XtRString, (XtPointer) "#000000" },
-  { XtNbackgroundToolBarColor, XtCBackgroundToolBarColor,
-    XtRPixel, sizeof (Pixel),
-    offset (background_toolbar_pixel), XtRImmediate, (XtPointer)-1 },
-  { XtNforegroundToolBarColor, XtCForegroundToolBarColor,
-    XtRPixel, sizeof (Pixel),
-    offset (foreground_toolbar_pixel), XtRImmediate, (XtPointer)-1 },
-  { XtNtopToolBarShadowPixmap, XtCTopToolBarShadowPixmap,
-    XtRPixmap, sizeof (Pixmap),
-    offset (top_toolbar_shadow_pixmap), XtRImmediate, (XtPointer)None },
-  { XtNbottomToolBarShadowPixmap, XtCBottomToolBarShadowPixmap,
-    XtRPixmap, sizeof (Pixmap),
-    offset (bottom_toolbar_shadow_pixmap), XtRImmediate, (XtPointer)None },
   { XtNtoolBarShadowThickness, XtCToolBarShadowThickness,
     XtRDimension, sizeof (Dimension),
     offset (toolbar_shadow_thickness), XtRImmediate, (XtPointer)2 },
Index: EmacsFrameP.h
===================================================================
RCS file: /pack/xemacscvs/XEmacs/xemacs/src/EmacsFrameP.h,v
retrieving revision 1.5
diff -u -w -u -w -r1.5 EmacsFrameP.h
--- EmacsFrameP.h	2001/04/12 18:23:22	1.5
+++ EmacsFrameP.h	2002/06/03 11:47:39
@@ -57,12 +57,6 @@
   int		bottom_toolbar_border_width;	/* ... of bottom toolbar */
   int		left_toolbar_border_width;	/* ... of left toolbar */
   int		right_toolbar_border_width;	/* ... of right toolbar */
-  Pixel		top_toolbar_shadow_pixel;
-  Pixel		bottom_toolbar_shadow_pixel;
-  Pixel		background_toolbar_pixel;
-  Pixel		foreground_toolbar_pixel;
-  Pixmap	top_toolbar_shadow_pixmap;
-  Pixmap	bottom_toolbar_shadow_pixmap;
   Dimension	toolbar_shadow_thickness;
   unsigned char scrollbar_placement;
   int		interline;		/* skips between lines */