1999-06-11  Jan Vroonhof  <vroonhof@math.ethz.ch>

	* xemacs.mak: Make Native build understand patch level's

Index: nt/xemacs.mak
===================================================================
RCS file: /usr/CVSroot/XEmacs/xemacs-20/nt/xemacs.mak,v
retrieving revision 1.52
diff -u -u -r1.52 xemacs.mak
--- xemacs.mak	1999/03/04 13:14:27	1.52
+++ xemacs.mak	1999/06/11 20:37:01
@@ -45,10 +45,10 @@
 	-DINFODOCK_MINOR_VERSION=$(infodock_minor_version)	\
 	-DINFODOCK_BUILD_VERSION=$(infodock_build_version)
 !else
-!if "$(emacs_beta_version)" != ""
+!if "$(emacs_is_beta)" != ""
 XEMACS_VERSION_STRING=$(emacs_major_version).$(emacs_minor_version)-b$(emacs_beta_version)
 !else
-XEMACS_VERSION_STRING=$(emacs_major_version).$(emacs_minor_version)
+XEMACS_VERSION_STRING=$(emacs_major_version).$(emacs_minor_version).$(emacs_beta_version)
 !endif
 PROGRAM_DEFINES=						\
 	-DPATH_VERSION=\"$(XEMACS_VERSION_STRING)\"		\
@@ -748,8 +748,10 @@
 # TEMACS Executable
 
 # This may not exist
-!if "$(emacs_beta_version)" != ""
+!if "$(emacs_is_beta)" != ""
 EMACS_BETA_VERSION=-DEMACS_BETA_VERSION=$(emacs_beta_version)
+!else
+EMACS_BETA_VERSION=-DEMACS_PATCH_LEVEL=$(emacs_beta_version)
 !ENDIF
 
 TEMACS_DIR=$(XEMACS)\src